
// loadBMP.cxx

#include "testap3.h"
#include <stdio.h>
//#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// #define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')	/* Simple "BM" ... */

BOOL bUseBitBlt = TRUE;

// WIDTHBYTES takes # of bits in a scan line and rounds up to nearest
//  dword (32-bits). The # of bits in a scan line would typically be
//  the pixel width (bmWidth) times the BPP (bits-per-pixel = bmBitsPixel)
//#define WIDTHBYTES(bits)      (((bits) + 31) / 32 * 4)

void SetWindowTitle( PTSTR pf )
{
   if( pf ) {
      if( lstrcmp( pf, m_szWinTitle ) ) {
         wsprintf( m_szTmpBuf, L"testap3 - %s", pf );
         SetWindowText( m_hMainWnd, m_szTmpBuf );
         lstrcpy( m_szWinTitle, pf );
      }
   } else {
      m_szWinTitle[0] = 0;
      SetWindowText( m_hMainWnd, L"testap3" );
   }
}

HANDLE   ReadBMPFile( PTSTR pFile )
{
   //ATL: USES_CONVERSION;
   //char * fn = W2CA( pFile ); NO use WideCharToMultiByte
   int   ret;
   WaitCursor cur;
   int   len = lstrlen( pFile );
   //PSTR  ps = _s_tmp_buf;
   PSTR  ps = (PSTR)MALLOC(1024);
   struct _stat sbuf;
   size_t   file_size;
   BITMAPFILEHEADER	bmfHeader;
   HANDLE hDIB = NULL;

   if( !ps )
      return NULL;

   ret = WideCharToMultiByte( CP_ACP, // UINT CodePage,            // code page
      0, // DWORD dwFlags,            // performance and mapping flags
      pFile,   // LPCWSTR lpWideCharStr,    // wide-character string
      len,     // int cchWideChar,          // number of chars in string.
      ps,      // LPSTR lpMultiByteStr,     // buffer for new string
      1024,    // int cbMultiByte,          // size of buffer
      NULL,    // LPCSTR lpDefaultChar,     // default for unmappable chars
      NULL );  // LPBOOL lpUsedDefaultChar  // set when default char used

   sbuf.st_size = 0;
   ps[len] = 0;
   ret = _stat( ps, &sbuf );
   if (( ret != 0 )||(sbuf.st_size < sizeof(bmfHeader)+10)) {
#ifndef DEBUG_LEAKS
      //free(ps);
      MFREE(ps);
#endif   // !DEBUG_LEAKS
      // failed
      return hDIB;
   }

   file_size = sbuf.st_size;  // get the FULL FILE SIZE

   FILE * pf = fopen( ps, "rb" );
   if( pf ) {
      size_t   sz;
      sz = fread( (void *)&bmfHeader, 1, sizeof(bmfHeader), pf );
  		if(( sz != sizeof( bmfHeader )             ) ||
         ( bmfHeader.bfType != DIB_HEADER_MARKER ) ) {
            // FAILED
            hDIB = NULL;
      } else {
         // SUCCESS - got BITMAP HEADER
         size_t dwread = file_size - sizeof(BITMAPFILEHEADER);
         hDIB = MALLOC(dwread);
         //hDIB = new BYTE[dwread];
         if(hDIB) {
            sz = fread(hDIB, 1, dwread, pf);
            if( sz != dwread ) {
               //delete hDIB;
               MFREE(hDIB);
               hDIB = NULL;
            }
         }
      }
      fclose(pf);
   }
#ifndef DEBUG_LEAKS
   //free(ps);
   MFREE(ps);
#endif   // !DEBUG_LEAKS
   return hDIB;
}

// InitBitmapInfoHeader - InitBMPInfoHeader
void InitBitmapInfoHeader( LPBITMAPINFOHEADER lpBmInfoHdr,
						  DWORD dwWidth,
						  DWORD dwHeight,
						  int nBPP )
{
	int		iBPP;
	//dv_fmemset( lpBmInfoHdr, 0, sizeof (BITMAPINFOHEADER) );
	ZeroMemory( lpBmInfoHdr, sizeof (BITMAPINFOHEADER) );

	lpBmInfoHdr->biSize      = sizeof(BITMAPINFOHEADER);
	lpBmInfoHdr->biWidth     = dwWidth;
	lpBmInfoHdr->biHeight    = dwHeight;
	lpBmInfoHdr->biPlanes    = 1;

	// Fix Bits per Pixel
	if( nBPP <= 1 )
		iBPP = 1;
	else if( nBPP <= 4 )
		iBPP = 4;
	else if( nBPP <= 8 )
		iBPP = 8;
	else
		iBPP = 24;

	lpBmInfoHdr->biBitCount  = iBPP;
	lpBmInfoHdr->biSizeImage = WIDTHBYTES(dwWidth * iBPP) * dwHeight;
}


HBITMAP BitmapFromDib ( HANDLE hdib, HPALETTE hpal )
{
    LPBITMAPINFOHEADER  lpbi;
    HPALETTE            hpalT;
    HDC                 hdc;
    HBITMAP             hbm = NULL;

    if (!hdib)
        return NULL;

    lpbi = (LPBITMAPINFOHEADER)hdib;

    hdc = GetDC(NULL);

    if( !hdc )
       return NULL;

    if (hpal) {
        hpalT = SelectPalette(hdc,hpal,FALSE);
        RealizePalette(hdc);     // GDI Bug...????
    }

    hbm = CreateDIBitmap(hdc,
                (LPBITMAPINFOHEADER)lpbi,
                (LONG)CBM_INIT,
                (LPSTR)lpbi + lpbi->biSize + DIBPaletteSize((LPSTR)lpbi),
                (LPBITMAPINFO)lpbi,
                DIB_RGB_COLORS );

    if (hpal)
        SelectPalette(hdc,hpalT,FALSE);

    ReleaseDC(NULL,hdc);

    return hbm;
}

BOOL DrawBitmap (HDC hdc, INT x, INT y, HBITMAP hbm, DWORD rop)
{
    HDC       hdcBits;
    BITMAP    bm;
    BOOL      f;

    if (!hdc || !hbm)
        return FALSE;

    hdcBits = CreateCompatibleDC(hdc);
    if( !hdcBits )
       return FALSE;

    GetObject( hbm, sizeof(BITMAP),(LPSTR)&bm );

    SelectObject( hdcBits, hbm );

    if( m_FlagStretch ) {
       RECT rc;
       SIZE sz;
       GetClientRect( m_hMainWnd, &rc );
       double ht = (((double)rc.right / (double)bm.bmWidth) * (double)bm.bmHeight );
       double wd = (((double)rc.bottom / (double)bm.bmHeight) * (double)bm.bmWidth);
       if((int)wd < rc.right ) {
          sz.cx = (int)wd;
          sz.cy = rc.bottom;
       } else {
          sz.cx = rc.right;
          sz.cy = (int)ht;
       }
       f = StretchBlt( hdc,      // handle to destination DC
          0, //int nXOriginDest, // x-coord of destination upper-left corner
          0, //int nYOriginDest, // y-coord of destination upper-left corner
          sz.cx, // int nWidthDest,   // width of destination rectangle
          sz.cy, // int nHeightDest,  // height of destination rectangle
          hdcBits,       // handle to source DC
          0,   // int nXOriginSrc,  // x-coord of source upper-left corner
          0,   // int nYOriginSrc,  // y-coord of source upper-left corner
          bm.bmWidth, // int nWidthSrc,    // width of source rectangle
          bm.bmHeight, // int nHeightSrc,   // height of source rectangle
          rop );  // DWORD dwRop       // raster operation code
    } else {
       f = BitBlt( hdc, x, y, bm.bmWidth, bm.bmHeight, hdcBits, 0, 0, rop );
    }

    DeleteDC(hdcBits);

    return f;
}

BOOL Process_Bitmap( HWND hWnd, HDC hdc, HANDLE hDIB, HBITMAP hbm )
{
   BOOL bRet = FALSE;
   if( hDIB && hbm )
   {
      if( m_hDIB )
         delete m_hDIB;
      if( m_hBitmap )
         DeleteObject(m_hBitmap);
      m_sDIBSize.cx = (LONG)DIBWidth (hDIB);
      m_sDIBSize.cy = (LONG)DIBHeight(hDIB);
      m_hDIB        = hDIB;
      m_hBitmap     = hbm;
      DrawBitmap( hdc, 0, 0, m_hBitmap, SRCCOPY ); // COPY it to the screen/window
      // this is to adjust SCROLL BARS, if BITMAP larger than window
      PostMessage( hWnd, WM_SIZE, 0, MAKELONG( g_wm_size.cx, g_wm_size.cy ));
      bRet = TRUE;
   }
   return bRet;
}

//---------------------------------------------------------------------
//
// Function:   CropBitmap
//
// Purpose:    Crops a bitmap to a new size specified by the lpRect
//             parameter.  The lpptSize parameter is used to determine
//             how much to stretch/compress the bitmap.  Returns a
//             handle to a new bitmap.  If lpRect is empty, copies the
//             bitmap to a new one.
//
//             Stolen almost verbatim out of ShowDIB.
//
// Parms:      hbm      == Handle to device dependent bitmap to crop.
//             hPal     == Palette to use in cropping (NULL for default pal.)
//             lpRect   == New bitmap's size (size we're cropping to).
//             lpptSize == A scaling factor scale by the proportion:
//                              Bitmap Width / lpptSize->x horizontally,
//                              Bitmap Height / lpptSize->y horizontally.
//                           Note that if lpptSize is set to the bitmap's
//                           dimensions, no scaling occurs.
//             
//
// History:   Date      Reason
//            6/15/91   Stolen from ShowDIB
//             
//---------------------------------------------------------------------

HBITMAP CropBitmap (HBITMAP hbm, HPALETTE hPal, LPRECT lpRect, LPPOINT pptSizeIn)
{
	HDC      hMemDCsrc;
	HDC      hMemDCdst;
	BITMAP   bm;
	int      dxDst,dyDst, dxSrc, dySrc;
	double   cxScale, cyScale;
	HPALETTE hOldPal1 = NULL;
	HPALETTE hOldPal2 = NULL;
	HBITMAP  hNewBm = NULL;
   POINT    pt;
   PPOINT   lpptSize = &pt;

	if( !hbm )		// Oops, no BITMAP!!!
		return NULL;

   if( !lpRect || IsRectEmpty( lpRect ) )
      return NULL;   // no go with EMPTY rectangle

   bm.bmHeight = 0;
   bm.bmWidth = 0;
	GetObject( hbm, sizeof(BITMAP), (LPSTR)&bm );

   // if we FAILED to get an object with dimensions
   if(( bm.bmHeight == 0 ) || ( bm.bmWidth == 0 ))
      return NULL;

	hMemDCsrc = CreateCompatibleDC( NULL );
   if( !hMemDCsrc )
      return NULL;

	hMemDCdst = CreateCompatibleDC( NULL );
   if( !hMemDCdst ) {
   	DeleteDC( hMemDCsrc );
      return NULL;
   }

   // we have potential SOURCE and DESTINATION

	if( hPal ) {   // only IF a palette given
		hOldPal1 = SelectPalette( hMemDCsrc, hPal, FALSE );
		hOldPal2 = SelectPalette( hMemDCdst, hPal, FALSE );
		RealizePalette( hMemDCdst );
	}

   // get CLIP width and height
	dxDst     = lpRect->right  - lpRect->left;
	dyDst     = lpRect->bottom - lpRect->top;
	if( (dxDst <= 0) || (dyDst <= 0) ) {   // if yielded ZERO, or negatives
		dxDst = bm.bmWidth;
		dyDst = bm.bmHeight;
	}

   if( pptSizeIn ) {
      pt = *pptSizeIn;
   } else {
      pt.x = bm.bmWidth;
      pt.y = bm.bmHeight;
   }

   // scale it, if POINT size not same as dimensions
	cxScale   = (double) bm.bmWidth  / lpptSize->x;
	cyScale   = (double) bm.bmHeight / lpptSize->y;
	dxSrc     = (int) ((double)(lpRect->right - lpRect->left) * cxScale);
	dySrc     = (int) ((double)(lpRect->bottom - lpRect->top) * cyScale);
   // ensure source is at least 1
	if( dxSrc == 0 )
		dxSrc = 1;

	if( dySrc == 0 )
		dySrc = 1;

	hNewBm = CreateBitmap( dxDst, dyDst, bm.bmPlanes, bm.bmBitsPixel, NULL );
	if( hNewBm ) {

		HBITMAP hOldBitmap1, hOldBitmap2;

		hOldBitmap1 = (HBITMAP)SelectObject( hMemDCsrc, hbm );   // current is SOURCE
		hOldBitmap2 = (HBITMAP)SelectObject( hMemDCdst, hNewBm );// NEW is DESTINATION

		StretchBlt( hMemDCdst,  // handle to destination DC
			0,             // x-coord of destination upper-left corner
			0,             // y-coord of destination upper-left corner
			dxDst,         // width of destination rectangle
			dyDst,         // height of destination rectangle
			hMemDCsrc,     // handle to source DC
			(int) (lpRect->left * cxScale),  // x-coord of source upper-left corner
			(int) (lpRect->top  * cyScale),  // y-coord of source upper-left corner
			dxSrc,                           // width of source rectangle
			dySrc,                           // height of source rectangle
			SRCCOPY );                       // raster operation code

      // replace OLD bitmaps!!!
		SelectObject( hMemDCsrc, hOldBitmap1 );
		SelectObject( hMemDCdst, hOldBitmap2 );
	}

   // clean up ...
	if( hOldPal1 )
		SelectPalette( hMemDCsrc, hOldPal1, FALSE );

	if( hOldPal2 )
		SelectPalette( hMemDCdst, hOldPal1, FALSE );

	DeleteDC( hMemDCsrc );
	DeleteDC( hMemDCdst );

	return hNewBm;
}	// End - HBITMAP CropBitmap(HBITMAP, HPALETTE, LPRECT, LPPOINT )

BOOL ReplaceClip( HDC hdc, HBITMAP hbm, PRECT prcClip )
{
   HDC hMemDCsrc;
	HBITMAP hOldBitmap;

   if( !hbm )
      return FALSE;

	hMemDCsrc = CreateCompatibleDC( NULL );
   if( !hMemDCsrc )
      return FALSE;

	hOldBitmap = (HBITMAP)SelectObject( hMemDCsrc, hbm );   // current is SOURCE

   if( bUseBitBlt ) {
      BitBlt( hdc,
         prcClip->left,
         prcClip->top,
         RECTWIDTH(prcClip),
         RECTHEIGHT(prcClip),
         hMemDCsrc,
         0,
         0,
         SRCCOPY );
   } else {
      StretchBlt( hdc,                      // handle to destination DC
         prcClip->left,             // x-coord of destination upper-left corner
         prcClip->top,             // y-coord of destination upper-left corner
         RECTWIDTH(prcClip),        // width of destination rectangle
         RECTHEIGHT(prcClip),       // height of destination rectangle
         hMemDCsrc,                 // handle to source DC
         0,                         // x-coord of source upper-left corner
         0,                         // y-coord of source upper-left corner
         RECTWIDTH(prcClip),        // width of source rectangle
         RECTHEIGHT(prcClip),       // height of source rectangle
         SRCCOPY );                 // raster operation code
   }

	SelectObject( hMemDCsrc, hOldBitmap );   // swap out current is SOURCE

   DeleteDC(hMemDCsrc);

   return TRUE;
}

void Delete_Loaded( void )
{
   HANDLE  hd = m_hDIB;
   m_hDIB = NULL;
#ifndef DEBUG_LEAKS
   if( hd )
      delete hd;
   if( m_hBitmap )
      DeleteObject(m_hBitmap);
#endif // !DEBUG_LEAKS
   m_hBitmap = NULL;
}

void CleanUp( void )
{
   Delete_Loaded();
   CLIP_cleanup();   // delete any CLIP BMP BLOCK
   KillAnim();       // delete any ANIM BMP blocks
}


BOOL IsBMPFile( char * ps )
{
   BOOL  bRet = FALSE;
   BITMAPFILEHEADER bmfh;
   FILE * pf = fopen( ps, "rb" );
   if( pf ) {
      size_t sz = fread( (void *)&bmfh, 1, sizeof(bmfh), pf );
      fclose(pf);
  		if(( sz != sizeof( bmfh )             ) ||
         ( bmfh.bfType != DIB_HEADER_MARKER ) ) {
         bRet = FALSE;  // FAILED
      } else {
         bRet = TRUE;
      }
   }
   return bRet;
}

BOOL Load_DIB_File( PTSTR pf )
{
   BOOL bRet = FALSE;
   HANDLE hDIB = ReadBMPFile( pf ); // READ BITMAP into DIB allocated memory
   if( hDIB ) {
      HDC hdc = GetDC( m_hMainWnd );
      if(hdc) {
         CLIP_cleanup();   // Delete any CLIP BLOCK BMP
         SetRectEmpty( &m_Clip );   // ZERO any outstanding CLIP
         Process_DIB( m_hMainWnd, hDIB, hdc );
         ReleaseDC(m_hMainWnd, hdc);
         Add2FileListHead(pf);
         SetWindowTitle( pf );
         bRet = TRUE;
      }
   } else {
      PTSTR ps = (PTSTR)GetNxtBuf();
      wsprintf(ps, L"WARNING: Seem UNABLE TO LOAD\r\n%s file.\r\nCheck name, and location!",
         pf );
      MessageBox( m_hMainWnd, ps, L"FILE LOAD FAILED",
         MB_OK | MB_ICONINFORMATION );
   }
   return bRet;
}

void Do_IDM_FILECLEAR( HWND hWnd )
{
   Delete_Loaded();
   SetWindowTitle( NULL );
   InvalidateRect(hWnd, NULL, TRUE);
}

// LoadBMP.cxx
