// testBubble.cxx

#include "testap3.h"

#define  DBG_HDC2BMPFILE
//#define  DBG_HDC2BMPFILE   HDC2BMPFILE  // to physically write the BMPs
#define DO_TEST_MAGNIFY

long  lgMagnif, lgBitCopy, lgDrawTrans;

BOOL  bTryNewTrans = FALSE; // Special transparency background mode on destination = FAILED
BOOL  bTryNewTrans2 = FALSE; // try using SRCINVERT/SRCAND = FAILED
BOOL  bTryNewTrans3 = FALSE; // Special transparency background mode on source = FAILED
BOOL  bTryNewTrans4 = TRUE; // service from MFC MaskedBitmap = SUCCESS!!!
BOOL  bUseBitBlt2 = TRUE;

int MagnifyPoint( HWND hWnd, POINT point );
void CMaskedBitmap_DrawTransparent(HDC hdcDst, HBITMAP hBmp, int x, int y, COLORREF clrTransparency);

// Track mouse, producing a bubble under it ...

/* =======================
   Idea is to use a rectangle, and enlarge the center
typedef struct tagBUB {
   SIZE szBub;
   POINT ptMouse;
   POINT ptCurr;
   RECT  rcOuter;
   RECT  rcInner;
   RECT  rcCenter;
   HBITMAP  hOrgBmp; // for replacement ...
   HDC   hdc;  // current device context
} BUB, * PBUB;
  ========================= */

BUB   sTBub = {0};

//void CreateBubble()
void CreateBubble( PBUB pbub )
{
   RECT rc, rc2, rc4;
   HDC   hdcDst = NULL;
   HDC   hdcSrc = NULL;
	HBITMAP hBitmap = NULL;
	HBITMAP hBitmap2 = NULL;  // handles to device-dependent bitmaps
   HBITMAP hBitmap4 = NULL;
   HBITMAP hOld, hOld2;  // handles to device-dependent bitmaps
   HDC   hdc = pbub->hdc;

   rc  = (*pbub).rcOuter;
   rc2 = (*pbub).rcInner;
   rc4 = (*pbub).rcCenter;

   hdcDst   = CreateCompatibleDC(hdc);
   hdcSrc   = CreateCompatibleDC(hdc);
	// create a bitmap compatible with the screen DC
	hBitmap  = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc), RECTWIDTH(&rc) );
   // transition - from here to outer
	hBitmap2 = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc2), RECTWIDTH(&rc2) );
   // center, to be expanded
	hBitmap4 = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc4), RECTWIDTH(&rc4) );
   if( !hdcDst || !hdcSrc || !hBitmap || !hBitmap2 || !hBitmap4 )
      goto Cleanup;

   // *********************************************************
   // 1. get OUTER rectangle, for replacement
   hOld = (HBITMAP)SelectObject( hdcDst, hBitmap );
   BitBlt( hdcDst, // handle to destination DC
      0,
      0,
      RECTWIDTH(&rc),
      RECTHEIGHT(&rc),
      hdc,
      rc.left,
      rc.top,
      SRCCOPY );
  	hBitmap = (HBITMAP)SelectObject( hdcDst, hOld );
   pbub->hOrgBmp = hBitmap;   // keep the COPY
   hBitmap = 0;   // clear so NO DELETE now

   // 2. Get the INNER rectangle ...
   hOld2 = (HBITMAP)SelectObject( hdcSrc, hBitmap4 );
   BitBlt( hdcSrc, // handle to destination DC
      0,
      0,
      RECTWIDTH(&rc4),
      RECTHEIGHT(&rc4),
      hdc,
      rc4.left,
      rc4.top,
      SRCCOPY );

   // 3. stretch the CENTER rect, to the size of the INNER rect
   StretchBlt( hdc,
      rc2.left,
      rc2.top,
      RECTWIDTH(&rc2),
      RECTHEIGHT(&rc2),
      hdcSrc,       // handle to source DC
      0,
      0,
      RECTWIDTH(&rc4),
      RECTHEIGHT(&rc4),
      SRCCOPY );
  	hBitmap4 = (HBITMAP)SelectObject( hdcSrc, hOld2 );
   // *********************************************************
   // MAYBE OUTLINE THE RECTANGLE
   DrawColoredRect( hdc, &rc2, RGB(255,0,0) );

Cleanup:
   if(hdcDst)
      DeleteDC(hdcDst);
   if(hdcSrc)
      DeleteDC(hdcSrc);
   if(hBitmap4)
      DeleteObject(hBitmap4);
   if(hBitmap2)
      DeleteObject(hBitmap2);
   if(hBitmap)
      DeleteObject(hBitmap);
}

void CreateBubble_OK( PBUB pbub )
{
   RECT rc, rc2, rc4;
   HDC   hdcDst = NULL;
   HDC   hdcSrc = NULL;
	HBITMAP hBitmap = NULL;
	HBITMAP hBitmap2 = NULL;  // handles to device-dependent bitmaps
	HBITMAP hBitmap4 = NULL;  // handles to device-dependent bitmaps
   HBITMAP hOld, hOld2, hOld4;  // handles to device-dependent bitmaps
   HDC   hdc = pbub->hdc;
   int i, diff;

   rc  = (*pbub).rcOuter;  // outer, maximum rect
   rc2 = (*pbub).rcInner;  // begin of transition region
   rc4 = (*pbub).rcCenter; // small, most inner RECT, to be expanded

   diff = rc.left - rc2.left;

   hdcDst   = CreateCompatibleDC(hdc);
   hdcSrc   = CreateCompatibleDC(hdc);
	// create a bitmap compatible with the screen DC
	hBitmap  = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc), RECTWIDTH(&rc) );
	hBitmap2 = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc2), RECTWIDTH(&rc2) );
	hBitmap4 = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc4), RECTWIDTH(&rc4) );
   if( !hdcDst || !hdcSrc || !hBitmap || !hBitmap2 || !hBitmap4 )
      goto Cleanup;

   // *********************************************************
   // get OUTER rectangle, for replacement
   hOld = (HBITMAP)SelectObject( hdcDst, hBitmap );
   BitBlt( hdcDst, // handle to destination DC
      0,
      0,
      RECTWIDTH(&rc),
      RECTHEIGHT(&rc),
      hdc,
      rc.left,
      rc.top,
      SRCCOPY );
  	hBitmap = (HBITMAP)SelectObject( hdcDst, hOld );
   pbub->hOrgBmp = hBitmap;   // keep the COPY

   // Get the CENTER rectangle ...
   hOld4 = (HBITMAP)SelectObject( hdcSrc, hBitmap4 );
   BitBlt( hdcSrc, // handle to destination DC
      0,
      0,
      RECTWIDTH(&rc4),
      RECTHEIGHT(&rc4),
      hdc,
      rc4.left,
      rc4.top,
      SRCCOPY );
   hBitmap4 = (HBITMAP)SelectObject( hdcSrc, hOld4 );

   // successive stretches, until down to inner
   // Deal with the TRANSITION AREA
   hOld2 = (HBITMAP)SelectObject( hdcSrc, hBitmap );
   for( i = 1; i < diff; i++ )
   {
   }
   SelectObject( hdcDst, hOld2 );

   // MAYBE OUTLINE THE RECTANGLE
   Rectangle( hdc, rc2.left-1, rc2.top-1, rc2.right+1, rc2.bottom+1 );

   // stretch the CENTER rect, to the size of the INNER rect
   hOld4 = (HBITMAP)SelectObject( hdcSrc, hBitmap4 );
   StretchBlt( hdc,
      rc2.left,
      rc2.top,
      RECTWIDTH(&rc2),
      RECTHEIGHT(&rc2),
      hdcSrc,       // handle to source DC
      0,
      0,
      RECTWIDTH(&rc4),
      RECTHEIGHT(&rc4),
      SRCCOPY );
  	hBitmap4 = (HBITMAP)SelectObject( hdcSrc, hOld4 );

   // *********************************************************
   hBitmap = 0;   // clear so NO DELETE now

Cleanup:
   if(hdcDst)
      DeleteDC(hdcDst);
   if(hdcSrc)
      DeleteDC(hdcSrc);
   if(hBitmap4)
      DeleteObject(hBitmap4);
   if(hBitmap2)
      DeleteObject(hBitmap2);
   if(hBitmap)
      DeleteObject(hBitmap);
}

void CreateBubble_OK2( PBUB pbub )
{
   RECT rc, rc2, rc4;
   HDC   hdcDst = NULL;
   HDC   hdcSrc = NULL;
	HBITMAP hBitmap = NULL;
   HBITMAP hOldBitmap, hOldBitmap2;  // handles to device-dependent bitmaps
	HBITMAP hBitmap2 = NULL;  // handles to device-dependent bitmaps
   HDC   hdc = pbub->hdc;

   rc  = (*pbub).rcOuter;
   rc2 = (*pbub).rcInner;
   rc4 = (*pbub).rcCenter; // small, most inner RECT, to be expanded

   hdcDst   = CreateCompatibleDC(hdc);
   hdcSrc   = CreateCompatibleDC(hdc);
	// create a bitmap compatible with the screen DC
	hBitmap  = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc), RECTWIDTH(&rc) );
	hBitmap2 = CreateCompatibleBitmap( hdc, RECTWIDTH(&rc2), RECTWIDTH(&rc2) );
   if( !hdcDst || !hdcSrc || !hBitmap || !hBitmap2 )
      goto Cleanup;

   // *********************************************************
   // get OUTER rectangle, for replacement
   hOldBitmap = (HBITMAP)SelectObject( hdcDst, hBitmap );
   BitBlt( hdcDst, // handle to destination DC
      0,
      0,
      RECTWIDTH(&rc),
      RECTHEIGHT(&rc),
      hdc,
      rc.left,
      rc.top,
      SRCCOPY );
  	hBitmap = (HBITMAP)SelectObject( hdcDst, hOldBitmap );
   pbub->hOrgBmp = hBitmap;   // keep the COPY
   hBitmap = 0;   // clear so NO DELETE now

   // Get the INNER rectangle ...
   hOldBitmap2 = (HBITMAP)SelectObject( hdcSrc, hBitmap2 );
   BitBlt( hdcSrc, // handle to destination DC
      0,
      0,
      RECTWIDTH(&rc2),
      RECTHEIGHT(&rc2),
      hdc,
      rc2.left,
      rc2.top,
      SRCCOPY );

   // stretch the INNER rect, to the size of the OUTER rect
   StretchBlt( hdc,
      rc.left,
      rc.top,
      RECTWIDTH(&rc),
      RECTHEIGHT(&rc),
      hdcSrc,       // handle to source DC
      0,
      0,
      RECTWIDTH(&rc2),
      RECTHEIGHT(&rc2),
      SRCCOPY );
  	hBitmap2 = (HBITMAP)SelectObject( hdcSrc, hOldBitmap2 );
   // *********************************************************

Cleanup:
   if(hdcDst)
      DeleteDC(hdcDst);
   if(hdcSrc)
      DeleteDC(hdcSrc);
   if(hBitmap2)
      DeleteObject(hBitmap2);
   if(hBitmap)
      DeleteObject(hBitmap);
}

void DeleteBubble( PBUB pbub )
{
   if(pbub->hOrgBmp && pbub->hdc)
   {
      HDC hdc    = pbub->hdc;
      HDC hdcSrc = CreateCompatibleDC(hdc);
      if(hdcSrc) {
         HBITMAP hold = (HBITMAP)SelectObject(hdcSrc, pbub->hOrgBmp);
         BitBlt( hdc, // handle to destination DC
            pbub->rcOuter.left,
            pbub->rcOuter.top,
            RECTWIDTH(&pbub->rcOuter),
            RECTHEIGHT(&pbub->rcOuter),
            hdcSrc,
            0,
            0,
            SRCCOPY );
         SelectObject(hdcSrc, hold);
         DeleteDC(hdcSrc);
      }
      pbub->hOrgBmp = NULL;
   }
}

void SetBUBRect( PBUB pbub )
{
   int cx = pbub->szBub.cx;
   int cy = pbub->szBub.cy;
   int cx2 = cx / 2;
   int cy2 = cy / 2;
   int cx4 = cx / 4;
   int cy4 = cy / 4;
   int x = pbub->ptMouse.x;
   int y = pbub->ptMouse.y;
   HDC hdc = pbub->hdc;

   if(( pbub->ptCurr.x != pbub->ptMouse.x )||
      ( pbub->ptCurr.y != pbub->ptMouse.y )) {
      DeleteBubble( pbub );
   }

   // FULL RECT
   pbub->rcOuter.left   = x - cx;
   pbub->rcOuter.right  = x + cx;
   pbub->rcOuter.top    = y - cy;
   pbub->rcOuter.bottom = y + cy;

   // HALF RECT
   pbub->rcInner.left   = x - cx2;
   pbub->rcInner.right  = x + cx2;
   pbub->rcInner.top    = y - cy2;
   pbub->rcInner.bottom = y + cy2;

   // INNER/CENTER RECT
   pbub->rcCenter.left   = x - cx4;
   pbub->rcCenter.right  = x + cx4;
   pbub->rcCenter.top    = y - cy4;
   pbub->rcCenter.bottom = y + cy4;

   // update to current position
   pbub->ptCurr.x = pbub->ptMouse.x;
   pbub->ptCurr.y = pbub->ptMouse.y;

   sprtf("Set RECT: Center %s (%dx%d), Inner %s (%dx%d), Outer %s (%dx%d)\n",
      GetRectStg(&pbub->rcCenter), RECTWIDTH(&pbub->rcCenter), RECTHEIGHT(&pbub->rcCenter),
      GetRectStg(&pbub->rcInner), RECTWIDTH(&pbub->rcInner), RECTHEIGHT(&pbub->rcInner),
      GetRectStg(&pbub->rcOuter),RECTWIDTH(&pbub->rcOuter), RECTHEIGHT(&pbub->rcOuter) );

}

void Do_Bubble( PBUB pbub, int x, int y )
{
   pbub->ptMouse.x = x;
   pbub->ptMouse.y = y;
   SetBUBRect( pbub );
   if( pbub->hOrgBmp ) { // = hBitMap;   // keep the COPY
      DeleteBubble( pbub );
   } else {
      //CreateBubble_OK( pbub );
      CreateBubble( pbub );
   }
}

extern int TEST_Magnify( HDC hdcDst, int x, int y, 
             SIZE sz, SIZE size, COLORREF clrTransparency );


void Do_IDM_TEST( HWND hWnd )
{
   POINT pt;
   pt.x = 217;
   pt.y = 218;
#ifdef DO_TEST_MAGNIFY
   HDC hdc = GetDC(hWnd);
   if( hdc ) {
      SIZE sz, size;
      COLORREF cr = RGB(255,0,254);
      sz.cx = 40;
      sz.cy = 40;
      size.cx = 120;
      size.cy = 120;
      TEST_Magnify( hdc, pt.x, pt.y, sz, size, cr );
      ReleaseDC(hWnd, hdc);
   }
#else // !DO_TEST_MAGNIFY
   MagnifyPoint( hWnd, pt );
#endif // DO_TEST_MAGNIFY y/n
}

void Do_IDM_TEST_2( HWND hWnd )
{
   RECT  rcClient;
   HDC   hdc;

   GetWindowRect( hWnd, &rcClient );
   hdc = GetDC(hWnd);
   if(hdc) {
      PBUB pbub      = &sTBub;
      pbub->hdc      = hdc;
      pbub->szBub.cx = gBubWid;
      pbub->szBub.cy = gBubHgt;
      Do_Bubble( pbub, m_Clip.left, m_Clip.top );
      ReleaseDC(hWnd, hdc);
   } else {
      MessageBox(hWnd, L"Failed to get HDC!", L"ERROR", MB_OK | MB_ICONINFORMATION );
   }
}

void Do_Bubble_Test( HWND hWnd, POINT pt )
{
   HDC hdc = GetDC(hWnd);
   if(hdc) {
      PBUB pbub      = &sTBub;
      pbub->hdc      = hdc;
      pbub->szBub.cx = gBubWid;
      pbub->szBub.cy = gBubHgt;
      Do_Bubble( pbub, pt.x, pt.y );
      ReleaseDC(hWnd, hdc);
   } else {
      MessageBox(hWnd, L"Failed to get HDC!", L"ERROR", MB_OK | MB_ICONINFORMATION );
   }
}

void MouseBubble( HWND hWnd, LPARAM lParam )
{
   HDC   hdc;
	MSG   msg;
   RECT  rcClient;
   INT   xPos = LOWORD (lParam);
   INT   yPos = HIWORD (lParam);

   hdc = GetDC(hWnd);
   if( !hdc )
      return;

   SetCapture( hWnd );

   GetWindowRect( hWnd, &rcClient );

   //CreateBubble( hdc, &rcClient, xPos, yPos );

   for( ; ; )
   {
		WaitMessage();

		// PeekMessage Return Values
		// If a message is available, the return value is nonzero.
		if( PeekMessage( &msg, NULL, WM_MOUSEFIRST, WM_MOUSELAST, PM_REMOVE ) )
		{
         xPos = LOWORD (msg.lParam);
         yPos = HIWORD (msg.lParam);
			if( msg.message == WM_LBUTTONUP ) {
            break; // we have completed tracking
			}
      }

   }

   ReleaseCapture();
   ReleaseDC( hWnd, hdc );

}


void DrawTransparent(HDC hdcDst, HDC dcImage,
                     int x, int y,
                     int cx, int cy,
                     COLORREF crColour)
{
   COLORREF crWhite = RGB(255,255,255);
   COLORREF crBlack = RGB(0,0,0);
	COLORREF crOldBack = SetBkColor(hdcDst, crWhite);
	//COLORREF crOldBack = SetBkColor(hdcDst, crColour);
	COLORREF crOldText = SetTextColor(hdcDst, crBlack);
   HDC dcTrans;

	// Create two memory dcs for the image and the mask
	dcTrans = CreateCompatibleDC(hdcDst);

	// Create the mask bitmap
	//int nWidth = Width();
	//int nHeight = Height();
   int nWidth = cx;
   int nHeight = cy;
	// Build mask based on transparent colour
	SetBkColor(dcImage, crColour);
	BitBlt(dcTrans, 0, 0, cx, cy, dcImage, 0, 0, SRCCOPY);

	// Do the work - True Mask method - cool if not actual display
	BitBlt(hdcDst, x, y, nWidth, nHeight, dcImage, 0, 0, SRCINVERT);
	BitBlt(hdcDst, x, y, nWidth, nHeight, dcTrans, 0, 0, SRCAND);
	BitBlt(hdcDst, x, y, nWidth, nHeight, dcImage, 0, 0, SRCINVERT);

	// Restore settings
	SetBkColor(hdcDst, crOldBack);
	SetTextColor(hdcDst, crOldText);
   DeleteDC( dcTrans );
}

void DrawTransparent_FAILED(HDC hdcDst, HBITMAP hBmp,
                     int x, int y,
                     int cx, int cy,
                     COLORREF crColour)
{
   COLORREF crWhite = RGB(255,255,255);
   COLORREF crBlack = RGB(0,0,0);
	COLORREF crOldBack = SetBkColor(hdcDst, crWhite);
	//COLORREF crOldBack = SetBkColor(hdcDst, crColour);
	COLORREF crOldText = SetTextColor(hdcDst, crBlack);
	HDC dcImage;
   HDC dcTrans;
   HBITMAP hOld;

	// Create two memory dcs for the image and the mask
	dcImage = CreateCompatibleDC(hdcDst);
	dcTrans = CreateCompatibleDC(hdcDst);

	// Select the image into the appropriate dc
	hOld = (HBITMAP)SelectObject(dcImage, hBmp);

	// Create the mask bitmap
	//int nWidth = Width();
	//int nHeight = Height();
   int nWidth = cx;
   int nHeight = cy;
	//bitmapTrans.CreateBitmap(nWidth, nHeight, 1, 1, NULL);
	HBITMAP bitmapTrans = CreateCompatibleBitmap(hdcDst, nWidth, nHeight);

	// Select the mask bitmap into the appropriate dc
	HBITMAP hOldBitmapTrans = (HBITMAP)SelectObject(dcTrans, bitmapTrans);

	// Build mask based on transparent colour
	SetBkColor(dcImage, crColour);
	BitBlt(dcTrans, 0, 0, cx, cy, dcImage, 0, 0, SRCCOPY);

	// Do the work - True Mask method - cool if not actual display
	BitBlt(hdcDst, x, y, nWidth, nHeight, dcImage, 0, 0, SRCINVERT);
	BitBlt(hdcDst, x, y, nWidth, nHeight, dcTrans, 0, 0, SRCAND);
	BitBlt(hdcDst, x, y, nWidth, nHeight, dcImage, 0, 0, SRCINVERT);

	// Restore settings
	SelectObject(dcImage, hOld);
	SelectObject(dcTrans, hOldBitmapTrans);
	SetBkColor(hdcDst, crOldBack);
	SetTextColor(hdcDst, crOldText);
   DeleteDC( dcImage );
   DeleteDC( dcTrans );
}

int MyPtInRegion( LPRGNDATA prd, int j, int y )
{
   PRECT prc = &prd->rdh.rcBound;
   POINT pt;
   pt.x = j;
   pt.y = y;
   if( PtInRect(prc,pt) ) {
      // that a good start
      DWORD max = prd->rdh.nCount;
      DWORD i;
      prc = (PRECT)&prd->Buffer[0];
      for(i = 0; i < max; i++) {
         if( PtInRect(prc,pt) )
            return 1;
         prc++;
      }
   }
   return 0;
}

// BitBlt(hdc, point.x-60, point.y-60, 120, 120, hdcMem, 0, 0, SRCCOPY);
void SlowBitCopy(HDC hdcDst, int x, int y, int cx, int cy,
                 HDC hdcSrc, int sx, int sy,
                 HRGN hrgn )
{
   TmStamp tm;
   //LPRGNDATA prd = GetRgnDataBlock(hrgn);
 	for(int i = sy; i < cy; i++ ) {
		for(int j = sx; j < cx; j++) {
         int pnt = 0;
         //if(prd)
         //   pnt = MyPtInRegion( prd, j, i );
         //else
         pnt = PtInRegion( hrgn, j, i );
         if( !pnt ) {
            COLORREF color = GetPixel(hdcSrc, j, i);
            SetPixel(hdcDst,
            x + (j - sx),
            y + (i - sy),
            color );
         }
      }
   }
   //if(prd)
   //   MFREE(prd);
   lgBitCopy = tm.elapsed();
//   sprtf( "SlowBitCopy: Elapsed = %ld usecs\n", tm.elapsed() );
//#ifndef NDEBUG
//   {
//      LARGE_INTEGER li;
//      tm.get_freq( &li );
//      sprtf( "Frequency = %I64d\n", li );
//   }
//#endif // !NDEBUG

}

int MagnifyPoint( HWND hWnd, POINT point )
{
   TmStamp tm;
   int   iret = 0;
   HRGN rgn1, rgn2, rgn3;
   HDC   hdc = GetDC(hWnd);
   HBITMAP bitmap = NULL;
   HBITMAP bitmap2 = NULL;
   HDC   hdcBmp = NULL;
   HBITMAP hold, hold2;
   HBRUSH   hbr = NULL;
   HDC   hdcMem = NULL;
   COLORREF rgbTransparent = gMagTC;   // RGB(255, 0, 254);
   SIZE szIN, szOUT;
   PSIZE pszin = &szIN;
   PSIZE pszout = &szOUT;
   INT   xi2, yi2;
   INT   xo2, yo2;

   // INNER AND OUTER SIZES
   pszin->cx  = gMagICX; // 40;
   pszin->cy  = gMagICY; // 40;
   pszout->cx = gMagOCX;   // 120
   pszout->cy = gMagOCY;   // 120
   // half INNER and OUTER sizes
   xi2 = pszin->cx  / 2;
   yi2 = pszin->cy  / 2;
   xo2 = pszout->cx / 2;
   yo2 = pszout->cy / 2;

   // create regions
   rgn1 = CreateEllipticRgn(0,0,pszout->cx,pszout->cy);
   rgn2 = CreateRectRgn(0,0,pszout->cx,pszout->cy);
   rgn3 = CreateRectRgn(0,0,pszout->cx,pszout->cy);
   if( !rgn1 || !rgn2 || !rgn3 )
      goto Cleanup;

   // ==============================================================
   CombineRgn(rgn3,rgn2,rgn1, RGN_DIFF); // subtract center ellipse,
   // from outer rectangle - gets a complex region
   // Try outputRgn() for diagnostics only
   // OutputRgn( hdc, rgn3 ); // this PAINTS all the RECT to the HDC
   // ==============================================================

   if( !hdc )
      goto Cleanup;

   hbr = CreateSolidBrush( rgbTransparent );

   hdcBmp = CreateCompatibleDC(hdc);
   if( !hdcBmp )
      goto Cleanup;
   hdcMem = CreateCompatibleDC(hdc);
   if( !hdcMem )
      goto Cleanup;

	bitmap  = CreateCompatibleBitmap( hdc, pszin->cx, pszin->cy );
   if( !bitmap )
      goto Cleanup;

   bitmap2 = CreateCompatibleBitmap( hdc, pszout->cx, pszout->cy );
   if( !bitmap2 )
      goto Cleanup;

   hold = (HBITMAP)SelectObject(hdcBmp,bitmap);
   hold2 = (HBITMAP)SelectObject(hdcMem,bitmap2);

   if( bUseBitBlt2 ) {
      BitBlt( hdcBmp, 0, 0, pszin->cx, pszin->cx,
         hdc, point.x - xi2, point.y - yi2, SRCCOPY );
      DBG_HDC2BMPFILE(hdcBmp, L"temp\\001hdcBmp.bmp");
   } else {
      // THIS IS VERY SLOW!!!
      RECT sel;
      SetRect( &sel, point.x - xi2, point.y - yi2, point.x + xi2, point.y + yi2);
	   int y = sel.top;
      int x = sel.left;
      int ymax = y + pszin->cy;
      int xmax = x + pszin->cx;
      // for no particular reason, do a PIXEL by PIXEL copy
	   for(int i = y; i < ymax; i++ ) {
		   for(int j = x; j < xmax; j++) {
            COLORREF color = GetPixel(hdc, j, i);
			   //int red = GetRValue(color);
			   //int green = GetGValue(color);
			   //int blue = GetBValue(color);
            SetPixel(hdcBmp, j-x, i-y, color );
		   }
	   }
   }

   // expand this inner rectangle to fill the outer rectangle
   //StretchBlt(hdc, point.x, point.y, 120, 120, hdcBmp, 0, 0, 40, 40, SRCCOPY);
   StretchBlt(hdcMem, 0, 0, pszout->cx, pszout->cy,
      hdcBmp, 0, 0, pszin->cx, pszin->cy, SRCCOPY);

   DBG_HDC2BMPFILE(hdcMem, L"temp\\002hdcMem1.bmp");
   // fill the outside the circle with the transparent color
   FillRgn( hdcMem, rgn3, hbr );
   DBG_HDC2BMPFILE(hdcMem, L"temp\\003hdcMem2.bmp");

	//	dc.SelectObject(&CPen(PS_SOLID, 1, RGB(0, 0, 0)));
	//	dc.SelectObject(&CBrush(NULL, RGB(0, 0, 0)));
	//	dc.Ellipse(point.x-(60*1)-1, point.y-(60*1)-1, point.x+(60*1), point.y+(60*1));

   // VARIOUS TRIES AT COPYING THE EXPANDED RECTANGLE TO THE SCREEN,
   // excluding the surrounding transparent region ...
   // Only attempt this if device supports functionality.
   //if(GetDeviceCaps(hdc, CAPS1) & C1_TRANSPARENT)
   if(bTryNewTrans)
   {
      // Special transparency background mode
      UINT oldMode = SetBkMode(hdc, NEWTRANSPARENT);
      COLORREF rgbBk = SetBkColor(hdc, rgbTransparent);
      // Actual blt is a simple source copy; transparency is automatic.
      // BitBlt(hdcDest, x, y, dx, dy, hdcSrc, x0, y0, SRCCOPY);
      BitBlt(hdc, point.x-60, point.y-60, 120, 120, hdcMem, 0, 0, SRCCOPY);
      SetBkColor(hdc, rgbBk);
      SetBkMode(hdc, oldMode);
   } else if( bTryNewTrans2 ) {
      //DrawTransparent( hdc, bitmap, point.x-60, point.y-60, 120, 120, rgbTransparent );
      DrawTransparent( hdc, hdcMem, point.x-60, point.y-60, 120, 120, rgbTransparent );
   } else if( bTryNewTrans3 ) {
      //DrawTransparent(&dc, point.x-(60*1), point.y-(60*1), RGB(255, 0, 254));
      UINT oldMode = SetBkMode(hdcMem, NEWTRANSPARENT);
      COLORREF rgbBk = SetBkColor(hdcMem, rgbTransparent);
      BitBlt(hdc, point.x-60, point.y-60, 120, 120, hdcMem, 0, 0, SRCCOPY);
      SetBkColor(hdcMem, rgbBk);
      SetBkMode(hdcMem, oldMode);
   } else if( bTryNewTrans4 ) {
      bitmap2 = (HBITMAP)SelectObject(hdcMem,hold2);
      CMaskedBitmap_DrawTransparent( hdc, bitmap2, point.x-60, point.y-60, rgbTransparent );
      hold2 = (HBITMAP)SelectObject(hdcMem,bitmap2);
   } else {
      SlowBitCopy(hdc, point.x-xo2, point.y-yo2, pszout->cx, pszout->cy,
         hdcMem, 0, 0, rgn3);
   }

   SelectObject(hdcBmp,hold);
   SelectObject(hdcMem,hold2);

Cleanup:
   if(hdc)
      ReleaseDC(hWnd, hdc);
   if(bitmap)
      DeleteObject(bitmap);
   if(bitmap2)
      DeleteObject(bitmap2);
   if(hdcBmp)
      DeleteDC(hdcBmp);
   if(hdcMem)
      DeleteDC(hdcMem);
   if(hbr)
      DeleteObject(hbr);
   if(rgn1)
      DeleteObject(rgn1);
   if(rgn2)
      DeleteObject(rgn2);
   if(rgn3)
      DeleteObject(rgn3);

   lgMagnif = tm.elapsed();

   if( bTryNewTrans4 ) {
      sprtf( "DrawTransparent: Elapsed = %ld usecs (%0.5f secs)\n", lgDrawTrans,
         ((double)lgDrawTrans / 1000000.0) );
   } else {
      sprtf( "SlowBitCopy: Elapsed = %ld usecs\n", lgBitCopy );
   }
   sprtf( "MagnifyPoint: Elapsed = %ld usecs (%0.5f secs)\n", lgMagnif,
      ((double)lgMagnif / 1000000.0) );
   
   return iret;
}

void CMaskedBitmap_DrawTransparent(HDC hdcDst, HBITMAP hBmp, int x, int y, COLORREF clrTransparency)
{
   TmStamp tm;
    BITMAP bm;
    //GetBitmap (&bm);
    GetObject( hBmp, sizeof(BITMAP), (LPSTR)&bm );
    //CPoint size (bm.bmWidth, bm.bmHeight);
    //pDC->DPtoLP (&size);
    //CPoint org (0, 0);
    //pDC->DPtoLP (&org);
    POINT size;
    size.x = bm.bmWidth;
    size.y = bm.bmHeight;
    DPtoLP( hdcDst, &size, 1 );
    POINT org;
    org.x = 0;
    org.y = 0;
    DPtoLP( hdcDst, &org, 1 );

	//
    // Create a memory DC (dcImage) and select the bitmap into it.
	//
    //CDC dcImage;
    //dcImage.CreateCompatibleDC (pDC);
   HDC dcImage = CreateCompatibleDC(hdcDst);
   // CBitmap* pOldBitmapImage = dcImage.SelectObject (this);
   HBITMAP pOldBitmapImage = (HBITMAP)SelectObject(dcImage, hBmp);
   // dcImage.SetMapMode (pDC->GetMapMode ());
   SetMapMode( dcImage, GetMapMode(hdcDst) );

	//
    // Create a second memory DC (dcAnd) and in it create an AND mask.
	//
   // CDC dcAnd;
   // dcAnd.CreateCompatibleDC (pDC);
   // dcAnd.SetMapMode (pDC->GetMapMode ());
   HDC dcAnd = CreateCompatibleDC (hdcDst);
   SetMapMode (dcAnd, GetMapMode (hdcDst));

   // CBitmap bitmapAnd;
   // bitmapAnd.CreateBitmap (bm.bmWidth, bm.bmHeight, 1, 1, NULL);
   // CBitmap* pOldBitmapAnd = dcAnd.SelectObject (&bitmapAnd);
   HBITMAP bitmapAnd = CreateBitmap (bm.bmWidth, bm.bmHeight, 1, 1, NULL);
   HBITMAP pOldBitmapAnd = (HBITMAP)SelectObject (dcAnd, bitmapAnd);

   // dcImage.SetBkColor (clrTransparency);
   // dcAnd.BitBlt (org.x, org.y, size.x, size.y, &dcImage, org.x, org.y,
   //     SRCCOPY);
   SetBkColor(dcImage, clrTransparency);
   BitBlt (dcAnd, org.x, org.y, size.x, size.y, dcImage, org.x, org.y,
        SRCCOPY);
   DBG_HDC2BMPFILE(dcAnd, L"temp\\004dcAnd.bmp");

	//
    // Create a third memory DC (dcXor) and in it create an XOR mask.
	//
   // CDC dcXor;
   // dcXor.CreateCompatibleDC (pDC);
   // dcXor.SetMapMode (pDC->GetMapMode ());
   HDC dcXor = CreateCompatibleDC (hdcDst);
   SetMapMode ( dcXor, GetMapMode (hdcDst) );

   // CBitmap bitmapXor;
   // bitmapXor.CreateCompatibleBitmap (&dcImage, bm.bmWidth, bm.bmHeight);
   // CBitmap* pOldBitmapXor = dcXor.SelectObject (&bitmapXor);
   HBITMAP bitmapXor = CreateCompatibleBitmap (dcImage, bm.bmWidth, bm.bmHeight);
   HBITMAP pOldBitmapXor = (HBITMAP)SelectObject (dcXor, bitmapXor);

    //dcXor.BitBlt (org.x, org.y, size.x, size.y, &dcImage, org.x, org.y,
    //    SRCCOPY);
   BitBlt (dcXor, org.x, org.y, size.x, size.y, dcImage, org.x, org.y,
        SRCCOPY);
   DBG_HDC2BMPFILE(dcXor, L"temp\\005dcXor1.bmp");

    //dcXor.BitBlt (org.x, org.y, size.x, size.y, &dcAnd, org.x, org.y,
    //    0x220326);
   BitBlt (dcXor, org.x, org.y, size.x, size.y, dcAnd, org.x, org.y,
        0x220326);
   DBG_HDC2BMPFILE(dcXor, L"temp\\006dcXor2.bmp");

	//
    // Copy the pixels in the destination rectangle to a temporary
    // memory DC (dcTemp).
	//
   // CDC dcTemp;
   // dcTemp.CreateCompatibleDC (pDC);
   // dcTemp.SetMapMode (pDC->GetMapMode ());
   HDC dcTemp = CreateCompatibleDC (hdcDst);
   SetMapMode ( dcTemp, GetMapMode (hdcDst) );

   // CBitmap bitmapTemp;
   // bitmapTemp.CreateCompatibleBitmap (&dcImage, bm.bmWidth, bm.bmHeight);
   // CBitmap* pOldBitmapTemp = dcTemp.SelectObject (&bitmapTemp);
   HBITMAP bitmapTemp = CreateCompatibleBitmap (dcImage, bm.bmWidth, bm.bmHeight);
   HBITMAP pOldBitmapTemp = (HBITMAP)SelectObject (dcTemp, bitmapTemp);

   // dcTemp.BitBlt (org.x, org.y, size.x, size.y, pDC, x, y, SRCCOPY);
   BitBlt (dcTemp, org.x, org.y, size.x, size.y, hdcDst, x, y, SRCCOPY);
   DBG_HDC2BMPFILE(dcTemp, L"temp\\007dcTemp0.bmp");

	//
    // Generate the final image by applying the AND and XOR masks to
    // the image in the temporary memory DC.
	//
   // dcTemp.BitBlt (org.x, org.y, size.x, size.y, &dcAnd, org.x, org.y,
   //     SRCAND);
   // dcTemp.BitBlt (org.x, org.y, size.x, size.y, &dcXor, org.x, org.y,
   //     SRCINVERT);
   BitBlt ( dcTemp, org.x, org.y, size.x, size.y, dcAnd, org.x, org.y,
        SRCAND);
   DBG_HDC2BMPFILE(dcTemp, L"temp\\008dcTemp1.bmp");
   BitBlt ( dcTemp, org.x, org.y, size.x, size.y, dcXor, org.x, org.y,
      SRCINVERT);
   DBG_HDC2BMPFILE(dcTemp, L"temp\\009dcTemp2.bmp");

   // Blit the resulting image to the screen.
   // pDC->BitBlt (x, y, size.x, size.y, &dcTemp, org.x, org.y, SRCCOPY);
   BitBlt ( hdcDst, x, y, size.x, size.y, dcTemp, org.x, org.y, SRCCOPY);
	//pDC->StretchBlt(x, y, cx, cy, &dcTemp, 0, 0, w, h, SRCCOPY);

   {
      RECT rc;
      rc.left   = x;
      rc.top    = y;
      rc.right  = rc.left + size.x;
      rc.bottom = rc.top + size.y;
      DrawColoredEllipse( hdcDst, &rc, RGB(255,0,0) );
   }

   // Restore the default bitmaps.
	//
   SelectObject ( dcTemp, pOldBitmapTemp);
   SelectObject ( dcXor,  pOldBitmapXor);
   SelectObject ( dcAnd,  pOldBitmapAnd);
   SelectObject ( dcImage, pOldBitmapImage);
   // delete objects
   DeleteDC(dcImage);
   DeleteDC(dcAnd);
   DeleteObject(bitmapAnd);
   DeleteDC(dcXor);
   DeleteObject(bitmapXor);
   DeleteDC(dcTemp);
   DeleteObject(bitmapTemp);

   lgDrawTrans = tm.elapsed();
}

/* ===============================
   from : Magnify source
void CMagnifierView::OnMouseMove(UINT nFlags, CPoint point) 
{
	SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR1));
	CPoint p = GetScrollPosition();
	CClientDC pdc(this);
	CMemDC dc(&pdc);
	m_dib.Draw(&dc, CPoint(-p.x, -p.y), m_dib.GetDimensions());
	CRect rect1(CPoint(0, 0), m_dib.GetDimensions());
	CRect sel;
	CMaskedBitmap* bitm;
	CMaskedBitmap* bit;
	if(rect1.PtInRect(point))
	{
		CRgn rgn1, rgn2;
		sel = CRect(point.x-(20*1), point.y-(20*1), point.x+(20*1), point.y+(20*1));
		CBitmapDC bitmap(40*1, 40*1, &dc);
		CBitmapDC bitmap2(120*1, 120*1, &dc);
		rgn1.CreateEllipticRgn(0, 0, 120, 120);
		rgn2.CreateRectRgn(0, 0, 120, 120);
		rgn1.CombineRgn(&rgn2, &rgn1, RGN_DIFF);
		int y = sel.top, x = sel.left;
		for(int i = y; i<y+(40*1);i++)
		{
			for(int j = x; j<x+(40*1); j++)
			{
				COLORREF color = dc.GetPixel(j, i);
				int red = GetRValue(color);
				int green = GetGValue(color);
				int blue = GetBValue(color);
				bitmap.SetPixel(j-x, i-y, color);
			}
		}
		bitm = bitmap.Close();
		CDC dcMem;
		dcMem.CreateCompatibleDC(&dc);
		dcMem.SelectObject(bitm);
		bitmap2.StretchBlt(0, 0, 120*1, 120*1, &dcMem, 0, 0, 40, 40, SRCCOPY);
		bitmap2.FillRgn(&rgn1, &CBrush(RGB(255, 0, 254)));
		bit = bitmap2.Close();
		dc.SelectObject(&CPen(PS_SOLID, 1, RGB(0, 0, 0)));
		dc.SelectObject(&CBrush(NULL, RGB(0, 0, 0)));
		dc.Ellipse(point.x-(60*1)-1, point.y-(60*1)-1, point.x+(60*1), point.y+(60*1));
		bit->DrawTransparent(&dc, point.x-(60*1), point.y-(60*1), RGB(255, 0, 254));
		dc.MoveTo(point.x, point.y-(60*1)-1);
		dc.LineTo(point.x, point.y-(10*1)+1);
		dc.MoveTo(point.x, point.y+(10*1)-1);
		dc.LineTo(point.x, point.y+(60*1)+1);
		dc.MoveTo(point.x-(60*1)-1, point.y);
		dc.LineTo(point.x-(10*1)+1, point.y);		
		dc.MoveTo(point.x+(10*1)-1, point.y);
		dc.LineTo(point.x+(60*1)+1, point.y);		
	}
	CScrollView::OnMouseMove(nFlags, point);
}

void CCISBitmap::DrawTransparent(CDC * pDC, int x, int y, COLORREF crColour)
{
	COLORREF crOldBack = pDC->SetBkColor(m_crWhite);
	COLORREF crOldText = pDC->SetTextColor(m_crBlack);
	CDC dcImage, dcTrans;

	// Create two memory dcs for the image and the mask
	dcImage.CreateCompatibleDC(pDC);
	dcTrans.CreateCompatibleDC(pDC);

	// Select the image into the appropriate dc
	CBitmap* pOldBitmapImage = dcImage.SelectObject(this);

	// Create the mask bitmap
	CBitmap bitmapTrans;
	int nWidth = Width();
	int nHeight = Height();
	bitmapTrans.CreateBitmap(nWidth, nHeight, 1, 1, NULL);

	// Select the mask bitmap into the appropriate dc
	CBitmap* pOldBitmapTrans = dcTrans.SelectObject(&bitmapTrans);

	// Build mask based on transparent colour
	dcImage.SetBkColor(crColour);
	dcTrans.BitBlt(0, 0, nWidth, nHeight, &dcImage, 0, 0, SRCCOPY);

	// Do the work - True Mask method - cool if not actual display
	pDC->BitBlt(x, y, nWidth, nHeight, &dcImage, 0, 0, SRCINVERT);
	pDC->BitBlt(x, y, nWidth, nHeight, &dcTrans, 0, 0, SRCAND);
	pDC->BitBlt(x, y, nWidth, nHeight, &dcImage, 0, 0, SRCINVERT);

	// Restore settings
	dcImage.SelectObject(pOldBitmapImage);
	dcTrans.SelectObject(pOldBitmapTrans);
	pDC->SetBkColor(crOldBack);
	pDC->SetTextColor(crOldText);
}

// from a Magnify project
// MaskedBitmap.cpp: implementation of the CMaskedBitmap class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MaskedBitmap.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void CMaskedBitmap::Draw(CDC *pDC, int x, int y)
{
    BITMAP bm;
    GetBitmap (&bm);
    CPoint size (bm.bmWidth, bm.bmHeight);
    pDC->DPtoLP (&size);

    CPoint org (0, 0);
    pDC->DPtoLP (&org);

    CDC dcMem;
    dcMem.CreateCompatibleDC (pDC);
    CBitmap* pOldBitmap = dcMem.SelectObject (this);
    dcMem.SetMapMode (pDC->GetMapMode ());

    pDC->BitBlt (x, y, size.x, size.y, &dcMem, org.x, org.y, SRCCOPY);

    dcMem.SelectObject (pOldBitmap);
}

void CMaskedBitmap::DrawTransparent(CDC *pDC, int x, int y, COLORREF clrTransparency)
{
    BITMAP bm;
    GetBitmap (&bm);
    CPoint size (bm.bmWidth, bm.bmHeight);
    pDC->DPtoLP (&size);

    CPoint org (0, 0);
    pDC->DPtoLP (&org);

	//
    // Create a memory DC (dcImage) and select the bitmap into it.
	//
    CDC dcImage;
    dcImage.CreateCompatibleDC (pDC);
    CBitmap* pOldBitmapImage = dcImage.SelectObject (this);
    dcImage.SetMapMode (pDC->GetMapMode ());

	//
    // Create a second memory DC (dcAnd) and in it create an AND mask.
	//
    CDC dcAnd;
    dcAnd.CreateCompatibleDC (pDC);
    dcAnd.SetMapMode (pDC->GetMapMode ());

    CBitmap bitmapAnd;
    bitmapAnd.CreateBitmap (bm.bmWidth, bm.bmHeight, 1, 1, NULL);
    CBitmap* pOldBitmapAnd = dcAnd.SelectObject (&bitmapAnd);

    dcImage.SetBkColor (clrTransparency);
    dcAnd.BitBlt (org.x, org.y, size.x, size.y, &dcImage, org.x, org.y,
        SRCCOPY);

	//
    // Create a third memory DC (dcXor) and in it create an XOR mask.
	//
    CDC dcXor;
    dcXor.CreateCompatibleDC (pDC);
    dcXor.SetMapMode (pDC->GetMapMode ());

    CBitmap bitmapXor;
    bitmapXor.CreateCompatibleBitmap (&dcImage, bm.bmWidth, bm.bmHeight);
    CBitmap* pOldBitmapXor = dcXor.SelectObject (&bitmapXor);

    dcXor.BitBlt (org.x, org.y, size.x, size.y, &dcImage, org.x, org.y,
        SRCCOPY);

    dcXor.BitBlt (org.x, org.y, size.x, size.y, &dcAnd, org.x, org.y,
        0x220326);

	//
    // Copy the pixels in the destination rectangle to a temporary
    // memory DC (dcTemp).
	//
    CDC dcTemp;
    dcTemp.CreateCompatibleDC (pDC);
    dcTemp.SetMapMode (pDC->GetMapMode ());

    CBitmap bitmapTemp;
    bitmapTemp.CreateCompatibleBitmap (&dcImage, bm.bmWidth, bm.bmHeight);
    CBitmap* pOldBitmapTemp = dcTemp.SelectObject (&bitmapTemp);

    dcTemp.BitBlt (org.x, org.y, size.x, size.y, pDC, x, y, SRCCOPY);

	//
    // Generate the final image by applying the AND and XOR masks to
    // the image in the temporary memory DC.
	//
    dcTemp.BitBlt (org.x, org.y, size.x, size.y, &dcAnd, org.x, org.y,
        SRCAND);

    dcTemp.BitBlt (org.x, org.y, size.x, size.y, &dcXor, org.x, org.y,
        SRCINVERT);

	//
    // Blit the resulting image to the screen.
	//
    pDC->BitBlt (x, y, size.x, size.y, &dcTemp, org.x, org.y, SRCCOPY);
	//pDC->StretchBlt(x, y, cx, cy, &dcTemp, 0, 0, w, h, SRCCOPY);
	//
    // Restore the default bitmaps.
	//
    dcTemp.SelectObject (pOldBitmapTemp);
    dcXor.SelectObject (pOldBitmapXor);
    dcAnd.SelectObject (pOldBitmapAnd);
    dcImage.SelectObject (pOldBitmapImage);
}

   ========================= */

// eof - testBubble.cxx
