
// testClip.cxx

#include "testap3.h"

char * pszDate = __DATE__;

BOOL bDebugClip = FALSE;
BOOL  bClipOnOff = FALSE;

RECT  rcClip = { 10, 10, 220, 120 };

RECT  rcClip1 = { 30, 30, 230, 140 };
POINT pBgn1 = { 130, 130 };
POINT pEnd1 = {  80, 30 };

//RECT  rcClip2 = { 30, 20, 230, 140 };
POINT pBgn = { 210, 20 };
POINT pEnd = { 130, 130 };

RECT  rcPrevClip;
// COLORREF crPen2 = RGB(255,0,0);
COLORREF crPen = RGB(255,255,0);

void DrawSelect( HDC hDC, LPRECT lprcClip )
{
	TCHAR	szStr[80];
	//DWORD	dwExt;
	int		x, y, nLen, dx, dy;
	HDC		hDCBits;
	HBITMAP	hBitmap, hOldmap;
   SIZE     sz;

	// Don't have anything to do if the rectangle is empty.
	if( ( hDC == 0 ) ||
		( lprcClip == 0 ) ||
		( IsRectEmpty( lprcClip ) ) )
		return;

	// Draw rectangular clip region
	PatBlt( hDC,
		lprcClip->left,
		lprcClip->top,
		lprcClip->right - lprcClip->left,
		1,
		DSTINVERT );

	PatBlt( hDC,
		lprcClip->left,
		lprcClip->bottom,
		1,
		-(lprcClip->bottom - lprcClip->top),
		DSTINVERT );

	PatBlt( hDC,
		lprcClip->right - 1,
		lprcClip->top,
		1,
		lprcClip->bottom - lprcClip->top,
		DSTINVERT );

	PatBlt( hDC,
		lprcClip->right,
		lprcClip->bottom - 1,
		-(lprcClip->right - lprcClip->left),
		1,
		DSTINVERT );

	hDCBits = CreateCompatibleDC( hDC );
   if(hDCBits) { // Output the text to a compatible DC
	   // Format the dimensions string
	   nLen = wsprintf( szStr,
		   L"%dx%d",
		   (lprcClip->right - lprcClip->left),
		   (lprcClip->bottom - lprcClip->top) );
	   // and center it in the rectangle
      GetTextExtentPoint32( hDC, szStr, nLen, &sz );
      dx = sz.cx;
      dy = sz.cy;
	   x  = (lprcClip->right  + lprcClip->left - dx) / 2;
	   y  = (lprcClip->bottom + lprcClip->top  - dy) / 2;
	   SetTextColor( hDCBits, RGB(255, 255, 255) );
	   SetBkColor(   hDCBits, RGB(  0,   0,   0) );
	   hBitmap = CreateBitmap( dx, dy, 1, 1, NULL );
	   if( hBitmap ) {
		   hOldmap = (HBITMAP)SelectObject( hDCBits, hBitmap );
		   ExtTextOut( hDCBits, 0, 0, 0, NULL, szStr, nLen, NULL );
		   BitBlt( hDC, x, y, dx, dy, hDCBits, 0, 0, SRCINVERT );
		   hOldmap = (HBITMAP)SelectObject( hDCBits, hOldmap );
		   DeleteObject( hBitmap );
	   }
	   DeleteDC( hDCBits );
   }
	rcPrevClip.left   = lprcClip->left;
	rcPrevClip.top    = lprcClip->top;
	rcPrevClip.right  = lprcClip->right;
	rcPrevClip.bottom = lprcClip->bottom;
}


BOOL Do_Arc( HDC hdc, PRECT prc, PPOINT pptB, PPOINT pptE )
{
   return( Arc(hdc,
       prc->left,
       prc->top,
       prc->right,
       prc->bottom,
       pptB->x,
       pptB->y,
       pptE->x,
       pptE->y ) );
}

void DrawCrossHairs( HDC hdc, PRECT prc )
{
   MoveToEx( hdc, ((prc->left + prc->right) / 2), prc->top, NULL ); // center top
   LineTo( hdc, ((prc->left + prc->right) / 2), prc->bottom ); // to center bottom
   MoveToEx( hdc, prc->left, ((prc->top + prc->bottom) / 2), NULL ); // center left
   LineTo( hdc, prc->right, ((prc->top + prc->bottom) / 2) );  // cetern right
}

void DrawDiagonals( HDC hdc, PRECT prc )
{
   MoveToEx( hdc, prc->left, prc->top, NULL );
   LineTo( hdc, prc->right, prc->bottom );
   MoveToEx( hdc, prc->left, prc->bottom, NULL );
   LineTo( hdc, prc->right, prc->top );
}

void DrawLine( HDC hdc, PPOINT pS, PPOINT pE )
{
   MoveToEx( hdc, pS->x, pS->y, NULL );
   LineTo( hdc, pE->x, pE->y );
}

void DrawQuarterRadials( HDC hdc, PRECT prc )
{
   POINT ptQ1, ptQ2;

   ptQ1.x = prc->left + (RECTWIDTH(prc) / 4);
   ptQ1.y = prc->top;
   ptQ2.x = prc->left + ((RECTWIDTH(prc) * 3) / 4);
   ptQ2.y = prc->bottom;
   DrawLine( hdc, &ptQ1, &ptQ2 );

   ptQ2.x = prc->left + (RECTWIDTH(prc) / 4);
   ptQ1.y = prc->top;
   ptQ1.x = prc->left + ((RECTWIDTH(prc) * 3) / 4);
   ptQ2.y = prc->bottom;
   DrawLine( hdc, &ptQ1, &ptQ2 );

   ptQ1.x = prc->left;
   ptQ1.y = prc->top + (RECTHEIGHT(prc) / 4);
   ptQ2.x = prc->right;
   ptQ2.y = prc->top + ((RECTHEIGHT(prc) * 3) / 4);
   DrawLine( hdc, &ptQ1, &ptQ2 );

   ptQ1.x = prc->left;
   ptQ2.y = prc->top + (RECTHEIGHT(prc) / 4);
   ptQ2.x = prc->right;
   ptQ1.y = prc->top + ((RECTHEIGHT(prc) * 3) / 4);
   DrawLine( hdc, &ptQ1, &ptQ2 );

}

typedef struct tagCLIPSWISH {
   RECT     rc;      // base rectangle
   int   penwidth;   // width of swish PEN
   COLORREF   cr;    // color of swish
   RECT     src1, src2;     // swish rectangle
   POINT    ptB1, ptE1; // first half of swish
   POINT    ptB2, ptE2; // second half of swish
} CLIPSWISH, * PCLIPSWISH;

CLIPSWISH   sActSwish;

void Draw_Colored_Swish( HDC hdc, PCLIPSWISH pcs )
{
   HPEN  hp;
   HPEN  hpOld = 0;
   hp = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      pcs->penwidth, // int nWidth,        // pen width
      pcs->cr ); //  COLORREF crColor   // pen color
   if(hp)
      hpOld = (HPEN)SelectObject(hdc, hp);

   Do_Arc( hdc, &pcs->src1, &pcs->ptB1, &pcs->ptE1 );
   Do_Arc( hdc, &pcs->src2, &pcs->ptB2, &pcs->ptE2 );

   if(hpOld)
      hpOld = (HPEN)SelectObject(hdc, hpOld);

}

void Set_Colored_Swish( HDC hdc, PRECT prc, int pw, COLORREF cr )
{
   RECT rc = *prc;
   PCLIPSWISH pcs = &sActSwish;
   if(( !EqualRect( &pcs->rc, &rc ) ) ||
      ( pcs->penwidth != pw ) ||
      ( pcs->cr != cr ) ) {
      int   halfp = pw / 2;
      pcs->rc = rc;
      pcs->penwidth = pw;
      pcs->cr = cr;
      rc.left   += halfp;
      rc.right  -= halfp;
      rc.top    += halfp;
      rc.bottom -= halfp;

      // full rectangle
      pcs->src1 = rc;
      // start on the 3/4 X, top Y radial
      pcs->ptB1.x = rc.left + ((RECTWIDTH(&rc) * 3) / 4);
      pcs->ptB1.y = rc.top;
      // end on the 1/2 X, bottom Y radial
      pcs->ptE1.x = (rc.left + rc.right) / 2;
      pcs->ptE1.y = rc.bottom;

      // inner rectangle (smaller, to wrap inside larger)
      rc.top += pw + 2; // adjust rectangle
      pcs->src2 = rc;
      // start on 1/2 X, Y bottom radial
      pcs->ptB2.x = (rc.left + rc.right) / 2;
      pcs->ptB2.y = rc.bottom;
      // end on the 1/4 X, Y top radial
      pcs->ptE2.x = rc.left + (RECTWIDTH(&rc) / 4);
      pcs->ptE2.y = rc.top;
   }

   if((RECTWIDTH(prc) > ( 4 * pw )) &&
      (RECTHEIGHT(prc) > ( 4 * pw ))) {
         Draw_Colored_Swish( hdc, pcs );
   }
}

void Draw_Debug( HDC hdc, PRECT prc )
{
   DrawQuarterRadials( hdc, prc );
   DrawCrossHairs( hdc, prc );
   DrawDiagonals( hdc, prc );
   RECT rc = *prc;
   rc.top += gPenW + 2; // adjust rectangle
   DrawQuarterRadials( hdc, &rc );
   DrawCrossHairs( hdc, &rc );
   DrawDiagonals( hdc, &rc );

}


void Draw_CLIP( HDC hdc )
{
   //Set_Colored_Swish( hdc, &rcClip2, g_SwishPenWidth, crPen2 );
   if( bDebugClip ) {
      Draw_Debug( hdc, &m_Clip );
   }
   DrawSelect( hdc, &m_Clip );
   Set_Colored_Swish( hdc, &m_Clip, gPenW, gPenC );
}

void CLIP_cleanup( void )
{
#ifndef  DEBUG_LEAKS
   if( m_hClipBMP )
      DeleteObject(m_hClipBMP);
#endif // !DEBUG_LEAKS

   m_hClipBMP = NULL;
   SetRectEmpty( &m_rcBMPRect );   // ZERO any RECT
}

void Do_IDM_ACTIONTEST( HWND hWnd )
{
   //Do_CLIP( hWnd );
   PRECT prcClip = &m_Clip;
   if( !IsRectEmpty( prcClip ) ) {
      HDC   hdc = GetDC(hWnd);
      if(hdc) {
         if(m_hBitmap) {
            m_hClipBMP = CropBitmap (m_hBitmap, NULL, prcClip, NULL);
            m_rcBMPRect = *prcClip;
         }
         Draw_CLIP( hdc );
         ReleaseDC(hWnd, hdc);
         bClipOnOff = TRUE;
      }
   }
}


// eof - clip.cxx
