// testCmd.cxx

// process the command line

#include "testap3.h"
#include <sys/types.h>
#include <wchar.h>
#include <sys/types.h>

#define  MB(a) MessageBox( NULL, a, L"COMMAND ERROR", MB_OK | MB_ICONINFORMATION )


int ParseCommandLine( PTSTR pCmd )
{
   int   iRet = 0;
   size_t   len = lstrlen(pCmd);
   if(len) {
      struct _stat buffer;
      size_t i, in;
      TCHAR c, d;
      PTSTR ps = (PTSTR)MALLOC(1024);
      PTSTR ps2 = (PTSTR)MALLOC(1024);
      PTSTR ps3 = (PTSTR)MALLOC(1024);
      if( !ps || !ps2 || !ps3 ) {
         MB( L"FAILED: NO MEMORY!!!\nAborting ..." );
         return 1;
      }
      wsprtf(L"CMD: [%s]\n", pCmd );
      in = 0;
      d = 0;
      for( i = 0; i < len; i++ ) {
         c = pCmd[i]; // extract char
         if(( c == '-' ) || ( c == '/' )) {
            // start with '-' or '/' char
            d = c;
            i++;
            c = pCmd[i];
            if( ( c == 'l' ) || ( c == 'L' ) ) {
               in = 0;
               i++;
               c = pCmd[i];
               d = 0;
               if( c == '"' )
                  d = c;
               else
                  ps[in++] = c;
               i++;
               for( ; i < len; i++ ) {
                  c = pCmd[i];
                  if( c == d )
                     break;
                  ps[in++] = c;
               }
               ps[in] = 0;
               buffer.st_size = 0;
               if( _wstat( ps, &buffer ) == 0 ) {
                  if( buffer.st_size ) {
                     Add2FileListHead( ps ); // insert in LIST, at HEAD
                     if( !gDoAuto ) {
                        gDoAuto = TRUE;
                     }
                  } else {
                     wsprintf( ps3, L"ERROR: File %s has no LENGTH!\nAborting", ps );
                     MB( ps3 );
                     iRet = 1;
                     goto Clean_up;
                  }
               } else {
                  _wgetcwd( ps2, 256 );
                  wsprintf( ps3, L"ERROR: Unable to locate file [%s]!\n"
                     L"CWD: %s\n"
                     L"Aborting", ps, ps2 );
                  MB( ps3 );
                  iRet = 1;
                  goto Clean_up;
               }
            } else {
               in = 0;
               ps[in++] = d;
               ps[in++] = c;
               i++;
               for( ; i < len; i++ )
               {
                  c = pCmd[i];
                  if( c <= ' ' )
                     break;
                  ps[in++] = c;
               }
               ps[in] = 0;
               wsprintf( ps3, L"ERROR: Unknown command [%s]!\nAborting", ps );
               MB( ps3 );
               iRet = 1;
               goto Clean_up;
            }
         } else {
            // bare value - assume an INPUT BMP file
            d = 0;
            in = 0;
            if( c == '"' )
               d = c;
            else
               ps[in++] = c;
            i++;
            for( ; i < len; i++ )
            {
               c = pCmd[i];
               if( c == d )
                  break;
               ps[in++] = c;
            }
            ps[in] = 0;
            buffer.st_size = 0;
            if( _wstat( ps, &buffer ) == 0 ) {
               if( buffer.st_size ) {
                  Add2FileListHead( ps ); // insert in LIST, at HEAD
                  if( !gDoAuto ) {
                     gDoAuto = TRUE;
                  }
               } else {
                  wsprintf( ps3, L"ERROR: File %s has no LENGTH!\nAborting",
                     ps );
                  MB( ps3 );
                  iRet = 1;
                  goto Clean_up;
               }
            } else {
               _wgetcwd( ps2, 256 );
               wsprintf( ps3, L"ERROR: Unable to locate file [%s]!\n"
                  L"CWD: %s\n"
                  L"Aborting",
                  ps,
                  ps2 );
               MB( ps3 );
               iRet = 1;
               goto Clean_up;
            }
         }
      }
Clean_up:
      MFREE(ps);
      MFREE(ps2);
      MFREE(ps3);
   }
   return iRet;
}

// eof - testCmd.cxx
