// testDib.h
#ifndef _testDib_H_
#define _testDib_H_

extern size_t DIBWidth (void * lpDIB);
extern size_t DIBHeight (void * lpDIB);
extern HANDLE BMPToDIB( HBITMAP hBitmap, HPALETTE hPal ); // uses MALLOC for memory
extern HANDLE DVBitmapToDIB( HBITMAP hBitmap, HPALETTE hPal ); // uses GlobalAlloc for memory

extern LPSTR FindDIBBits (LPSTR lpbi);
extern size_t DIBNumColors ( void * pv );
extern DWORD DIBCompression( void * pv );
extern PTSTR DIBCompressionStg( void * pv );
extern size_t DIBPaletteSize (LPSTR lpbi);
extern size_t PaletteSize (LPSTR lpbi);
extern DWORD	DIBBitCount( LPSTR lpbi );
extern BOOL Process_DIB( HWND hWnd, HANDLE hDIB, HDC hdc);

// WIDTHBYTES takes # of bits in a scan line and rounds up to nearest
//  dword (32-bits). The # of bits in a scan line would typically be
//  the pixel width (bmWidth) times the BPP (bits-per-pixel = bmBitsPixel)
#define WIDTHBYTES(bits)      (((bits) + 31) / 32 * 4)
#define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')	/* Simple "BM" ... */

// diagnostic only
extern void Out_Bmp_Hdr_Size( void );

#endif // _testDib_H_
// eof - testDib.h
