// Utils.cxx

#include "testap3.h"

PTSTR GetNxtBuf( VOID )
{
#define  MX_LINES    64
#define  MX_ONELINE  264
   static int iNxtLine = 0;
   static TCHAR nxtline[MX_LINES][MX_ONELINE];
   iNxtLine++;
   if( iNxtLine >= MX_LINES )
      iNxtLine = 0;
   return nxtline[iNxtLine];
}

//#define  DEF_CP   CP_ACP
#define  DEF_CP   CP_UTF8

char * GetRectStg( PRECT prc ) // like &m_Clip
{
   char * ps = (char *)GetNxtBuf();
   sprintf(ps, "(%d,%d,%d,%d)", prc->left, prc->top, prc->right, prc->bottom );
   return ps;
}

char * GetPointStg( PPOINT pp )
{
   char * ps = (char *)GetNxtBuf();
   sprintf(ps, "(%d,%d)", pp->x, pp->y );
   return ps;
}


PTSTR wGetRectStg( PRECT prc ) // like &m_Clip
{
   PTSTR ps = GetNxtBuf();
   wsprintf(ps, L"(%d,%d,%d,%d)", prc->left, prc->top, prc->right, prc->bottom );
   return ps;
}

BOOL DisableControl( HWND hDlg, UINT uiCtl )
{
   BOOL flg = FALSE;
   HWND hwnd = GetDlgItem( hDlg, uiCtl );
   if( hwnd ) {
      ShowWindow( hwnd, SW_HIDE );
      EnableWindow( hwnd, FALSE );
      flg = TRUE;
   }
   return flg;
}

BOOL EnableControl( HWND hDlg, UINT uiCtl )
{
   BOOL flg = FALSE;
   HWND hwnd = GetDlgItem( hDlg, uiCtl );
   if( hwnd ) {
      ShowWindow( hwnd, SW_SHOW );
      EnableWindow( hwnd, TRUE );
      flg = TRUE;
   }
   return flg;
}

int SetBoolItem( BOOL uChk, PBOOL pib, PBOOL pic )
{
   int iRet = 0;
   if( uChk ) {
      if ( ! *pib ) {
         *pib = TRUE;
         *pic = TRUE;
         iRet = 1;
      }
   } else {
      if ( *pib ) {
         *pib = FALSE;
         *pic = TRUE;
         iRet = 2;
      }
   }
   return iRet;
}

int Wide2UTF8( PTSTR pFile, char * ps, int len )
{
   int wlen = lstrlen(pFile);
   int ret = WideCharToMultiByte( DEF_CP, // UINT CodePage,            // code page
      0, // DWORD dwFlags,            // performance and mapping flags
      pFile,   // LPCWSTR lpWideCharStr,    // wide-character string
      wlen,     // int cchWideChar,          // number of chars in string.
      ps,      // LPSTR lpMultiByteStr,     // buffer for new string
      len,    // int cbMultiByte,          // size of buffer
      NULL,    // LPCSTR lpDefaultChar,     // default for unmappable chars
      NULL );  // LPBOOL lpUsedDefaultChar  // set when default char used
   return ret;
}

BOOL CenterWindow(HWND hwndChild, HWND hwndParent)
{
    RECT    rcChild, rcParent;
    int     cxChild, cyChild, cxParent, cyParent;
    int     cxScreen, cyScreen, xNew, yNew;
    HDC     hdc;

    // Get the Height and Width of the child window
    GetWindowRect(hwndChild, &rcChild);
    cxChild = rcChild.right - rcChild.left;
    cyChild = rcChild.bottom - rcChild.top;

    // Get the Height and Width of the parent window
    GetWindowRect(hwndParent, &rcParent);
    cxParent = rcParent.right - rcParent.left;
    cyParent = rcParent.bottom - rcParent.top;

    // Get the display limits
    hdc = GetDC(hwndChild);
    cxScreen = GetDeviceCaps(hdc, HORZRES);
    cyScreen = GetDeviceCaps(hdc, VERTRES);
    ReleaseDC(hwndChild, hdc);

    // Calculate new X position, then adjust for screen
    xNew = rcParent.left + ((cxParent - cxChild) / 2);
    if (xNew < 0)
    {
         xNew = 0;
    }
    else if ((xNew + cxChild) > cxScreen)
    {
        xNew = cxScreen - cxChild;
    }

    // Calculate new Y position, then adjust for screen
    yNew = rcParent.top  + ((cyParent - cyChild) / 2);
    if (yNew < 0)
    {
        yNew = 0;
    }
    else if ((yNew + cyChild) > cyScreen)
    {
        yNew = cyScreen - cyChild;
    }

    // Set it, and return
    return SetWindowPos(hwndChild,
                        NULL,
                        xNew, yNew,
                        0, 0,
                        SWP_NOSIZE | SWP_NOZORDER);
}

PTSTR m_strrchr( PTSTR ps, int chr )
{
   PTSTR rps = NULL;
   while( ps[0] )
   {
      if( ps[0] == chr )
         rps = ps;

      ps++;
   }

   return rps;
}



PTSTR m_strchr( PTSTR ps, int chr )
{
   while( ps[0] )
   {
      if( ps[0] == chr )
         return ps;

      ps++;
   }

   return NULL;
}

BOOL  Chk4Debug( PTSTR lpd )
{
   BOOL     bret = FALSE;
   PTSTR ptmp = &m_szTmpBuf[0];
   PTSTR   p;
   DWORD  dwi;

   lstrcpy(ptmp, lpd);
   dwi = lstrlen(ptmp);
   if(dwi)
   {
      dwi--;
      if(ptmp[dwi] == '\\')
      {
         ptmp[dwi] = 0;
         p = m_strrchr(ptmp, '\\');
         if(p)
         {
            p++;
            if( lstrcmpi(p, L"DEBUG") == 0 )
            {
               *p = 0;
               lstrcpy(lpd,ptmp);    // use this
               bret = TRUE;
            }
         }
      }
   }
   return bret;
}

void  GetModulePath( PTSTR lpb )
{
   LPTSTR   p;
   GetModuleFileName( NULL, lpb, 256 );
   p = m_strrchr( lpb, '\\' );
   if( p )
      p++;
   else
      p = lpb;
   *p = 0;
#ifndef  NDEBUG
   Chk4Debug( lpb );
#endif   // !NDEBUG

}

// eof - Utils.cxx
