// testap3.cxx : Defines the entry point for the application.
//

#include "testap3.h"
#include "showrt.h"
#include <time.h>
//#include <tchar.h>

#define  TRY_PEEK_MESSAGE

// Global Variables:
HACCEL hAccelTable = 0;
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

#define  MB(a) MessageBox( NULL, a, L"CRITICAL ERROR", MB_OK | MB_ICONINFORMATION )

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);


// _CRTDBG_LEAK_CHECK_DF
// _CRTDBG_CHECK_CRT_DF
// _CRTDBG_CHECK_ALWAYS_DF
#define  newFlag (_CRTDBG_ALLOC_MEM_DF | \
   _CRTDBG_LEAK_CHECK_DF | \
   _CRTDBG_DELAY_FREE_MEM_DF )

static int ProcessEvents( void )
{
  MSG msg;
  while ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
  {
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
         TranslateMessage( &msg ) ;
         DispatchMessage ( &msg ) ;
      }
      if( msg.message == WM_QUIT )
         return 0;
  }
  return 1;
}

extern void Do_Frame_Rate(void);

static void DoFrame(void)
{
   Do_Frame_Rate();
}

int APIENTRY wWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
 	// TODO: Place code here.
	MSG msg;
   TmStamp tm;
#ifdef   ADD_MEMORY_DEBUG
   _CrtSetDbgFlag( newFlag );
#endif // ADD_MEMORY_DEBUG

   add_sys_time(1);
   set_log_file("temptest3.txt");

   if( !InitGlobal() ) {
      MB( L"Failed in InitGlobal ... aborting ..." );
		return FALSE;
   }

   ReadINI();  // load INI file
   // then parse the command line
   if( ParseCommandLine( lpCmdLine ) ) {
      //MB( L"Failed: Error in command line ... aborting ..." );
		return FALSE;
   }

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TESTAP3, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
      MB( L"Failed in InitInstance ... aborting ..." );
		return FALSE;
	}


#ifdef	ADD_TIMER1
	if( !(uiTimer1 = SetTimer( m_hMainWnd, TIMER_ID1, TIMER_INTERVAL1, NULL)) )
	{
      MB( L"Failed in get Timer ... aborting ..." );
      return FALSE;
	}
#endif	/* ADD_TIMER1 */

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));
   if( !hAccelTable ) {
      MB( L"Failed to load accelerator ... aborting ..." );
      return FALSE;
   }

   Out_Bmp_Hdr_Size();
	sprtf( "Entering main message loop ...\n" );
   msg.wParam = 0;
#ifdef TRY_PEEK_MESSAGE
   while( ProcessEvents() )
   {
      DoFrame();
   }
#else // use standard stuff
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
#endif // TRY_PEEK_MESSAGE y/n

   WriteINI();
   KillFileList();
   CleanUp();
   // ===============================================
   FreeGlobal();  // toss the GLOBAL memory block.
   {
      TMSTAMP ts;
      long elap = tm.elapsed();
      tm.set_secs_struct( elap, &ts );
   	sprtf( "Program exit ... after %ld secs (%0.5f).\n", ts.secs,
         tm.get_secs_d(elap) );
   }
   //_CrtDumpMemoryLeaks();
	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TESTAP3));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_TESTAP3);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   g_hInst = hInstance; // Store instance handle in our global variable

   m_hMainWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!m_hMainWnd)
   {
      return FALSE;
   }

#ifdef   ADD_STATUS_BAR
   m_hStatusWnd = CreateStatusWindow(
      WS_CHILD | WS_VISIBLE,  // LONG style,
      L"Ready", // LPCTSTR lpszText,
      m_hMainWnd,    // HWND hwndParent,
      IDC_STATUSBAR ); // UINT wID
#endif // #ifdef   ADD_STATUS_BAR

   if( gbGotWP )
      SetWindowPlacement(m_hMainWnd,&g_sWP);
   else
      ShowWindow(m_hMainWnd, nCmdShow);

   UpdateWindow(m_hMainWnd);

   return TRUE;
}

void Delete_Resources( void )
{

}

BOOL Do_WM_MOUSEMESSAGE(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   BOOL handled = FALSE;
	switch (message)
	{
   case WM_MOUSEMOVE:
      Do_WM_MOUSEMOVE( hWnd, wParam, lParam );
      handled = TRUE;
      break;
#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
   case WM_MOUSEWHEEL:
      Do_WM_MOUSEWHEEL( hWnd, wParam, lParam );
      handled = TRUE;
      break;
#endif   // #if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
	case WM_LBUTTONDOWN:
      //Do_WM_LBUTTONDOWN( hWnd, wParam, lParam );
      MouseMagnify( hWnd, lParam );
      handled = TRUE;
      break;
   }
   return handled;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   LRESULT  lRes = 0;
   if( IsMouseMessage(message) ) {
      //wsprtf( L"msg: %s\n", GetMouseMsgName(message) );
      if( Do_WM_MOUSEMESSAGE(hWnd, message, wParam, lParam) )
         return lRes;
      else
   		return DefWindowProc(hWnd, message, wParam, lParam);
   }

	switch (message)
	{
	case WM_COMMAND:
      lRes = Do_WM_COMMAND(hWnd, wParam, lParam);
		break;
   case WM_CONTEXTMENU:
      Do_WM_CONTEXTMENU( hWnd, wParam, lParam );
      break;
   case WM_INITMENUPOPUP:
      Do_WM_INITMENUPOPUP( hWnd, wParam, lParam );
      break;
   case WM_SIZE:
      Do_WM_SIZE( hWnd, lParam );
      break;
   case WM_MOVE:
      UpdateWP( hWnd );
      break;
	case WM_PAINT:
      Do_WM_PAINT( hWnd );
		break;
//   case WM_MOUSEMOVE:
//      Do_WM_MOUSEMOVE( hWnd, wParam, lParam );
//      break;
   case WM_KEYDOWN:
      Do_WM_KEYDOWN( hWnd, wParam, lParam );
      break;
   case WM_KEYUP:
      Do_WM_KEYUP( hWnd, wParam, lParam );
      break;
   case WM_VSCROLL:
      Do_WM_VSCROLL( hWnd, wParam, lParam );
      break;
   case WM_HSCROLL:
      Do_WM_HSCROLL( hWnd, wParam, lParam );
      break;
//#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
//   case WM_MOUSEWHEEL:
//      Do_WM_MOUSEWHEEL( hWnd, wParam, lParam );
//      break;
//#endif   // #if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
#ifdef	ADD_TIMER1
   case WM_TIMER:
      Do_WM_TIMER( hWnd );
      break;
#endif	/* ADD_TIMER1 */
//	case WM_LBUTTONDOWN:
//      Do_WM_LBUTTONDOWN( hWnd, wParam, lParam );
//      break;
	case WM_DESTROY:
      Delete_Resources();
		PostQuitMessage(0);
		break;
		// Ensure that the clipboard data can be rendered even though
		//  this window is being destroyed.  First open the clipboard.
		//  Then empty what we put there earlier and re-render everything.
	case WM_RENDERALLFORMATS:
      Do_WM_RENDERALLFORMATS( hWnd );
		break;
		// Format the data in the manner requested and pass the handle of
		// the data to the clipboard.
	case WM_RENDERFORMAT:
      Do_WM_RENDERFORMAT( hWnd, wParam );
      break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return lRes;
}


// eof - testap3.cxx
